#include<string.h>
#include<stdio.h>
#include<fcntl.h>
#include<io.h>

typedef struct
{
      int  BM;
      long FZ;
      long U1;
      long HZ;
      long U2;
      long PX;
      long PY;
      int  U3;
      int  BP;
      long U4;
      long AP;
      char UP[16];
      char PL[1024];
}     BMPH;

unsigned char NAME1[80],NAME2[80],NAME3[80],BUF1[1025],BUF2[1025],BUF3[1025];
unsigned int T,TMP,PAGEGOR1,PAGEVER1,PAGEGOR2,PAGEVER2;
int RT1,RT2,RT3,A1,A2,A3;
long I,J;
BMPH HEDFI1,HEDFI2;

main(int argc, char *argv[])
{
     if(argc!=4)
     {
        printf("\n `BMPMIX` - mixing of 2 images in 8-bit BMP format;");
        printf("\n valid line size 1024 bytes or below.");
	printf("\n (E.H.Hauser, Baku, 03/01/01, 02:00:00, size 20113)");
        printf("\n Usage: >bmpmix.exe <name1.bmp> <name2.bmp> <target.bmp>\n");
        exit(0);
     }
     strcpy(NAME1,strupr(argv[1]));
     strcpy(NAME2,strupr(argv[2]));
     strcpy(NAME3,strupr(argv[3]));
     RT1=open(NAME1,O_RDWR|O_BINARY);
     if(RT1<0)
     {
        printf("Access error!\n"); sleep(2); exit(1);
     }
     I=filelength(RT1); if(I<1079) goto L111;
     read(RT1,&HEDFI1,1078);
     PAGEGOR1=(unsigned)HEDFI1.PX;
     PAGEVER1=(unsigned)HEDFI1.PY;
     if(HEDFI1.HZ!=1078) goto L111;
     if(HEDFI1.BP!=8) goto L111;
     RT2=open(NAME2,O_RDWR|O_BINARY);
     if(RT2<0)
     {
        printf("Access error!\n"); sleep(2); exit(1);
     }
     I=filelength(RT2); if(I<1079) goto L111;
     read(RT2,&HEDFI2,1078);
     PAGEGOR2=(unsigned)HEDFI2.PX;
     PAGEVER2=(unsigned)HEDFI2.PY;
     if(HEDFI2.HZ!=1078) goto L111;
     if(HEDFI2.BP!=8) goto L111;
     if(PAGEGOR1!=PAGEGOR2 || PAGEVER1!=PAGEVER2 || PAGEGOR1>1024) goto L222;
     RT3=_creat(NAME3,0);close(RT3);
     RT3=open(NAME3,O_RDWR|O_BINARY);
     if (RT3<0)
     {
        printf("Access error!\n"); sleep(2); exit(1);
     }
     write(RT3,&HEDFI1,1078); memset(BUF3,0,1025);
     for(J=0;J<PAGEVER1;J++)
     {
         lseek(RT1,1078+PAGEGOR1*J,SEEK_SET);
         read(RT1,BUF1,PAGEGOR1);
         lseek(RT2,1078+PAGEGOR2*J,SEEK_SET);
         read(RT2,BUF2,PAGEGOR2);
         for(I=0;I<PAGEGOR1;I++)
         {
             A1=(int)BUF1[I]; A2=(int)BUF2[I];
             A3=(A1+A2)/2; BUF3[I]=(unsigned char)A3;
         }
         write(RT3,BUF3,PAGEGOR1);
         T=(int)(J*100/PAGEVER1);TMP=wherey();
         gotoxy(1,TMP);printf("%i%s",T,"% ");
     }
     close(RT1);close(RT2);close(RT3);
     exit(0);

L111:  printf("\n Format/data error in file");sleep(2);exit(1);
L222:  printf("\n Error in file size");sleep(2);exit(1);

}
